from dataclasses import dataclass
from typing import Awaitable, Callable

from paircd.client import Client
from paircd.message import Message
from paircd.server import Server

HandlerFunc = Callable[
    [Server, Client, Message],
    Awaitable[None],
]


@dataclass
class CommandHandler:
    cmd: str
    argc: int
    handler: HandlerFunc
