import logging

from paircd.client import Client
from paircd.command_handler import CommandHandler
from paircd.log import log_client
from paircd.message import Message
from paircd.server import Server


async def handle_user(server: Server, client: Client, msg: Message) -> None:
    if client.registered:
        log_client(client, "USER issued after registration", level=logging.WARN)
        return

    client.username = msg.args[0]
    client.realname = msg.args[3]

    if client.nickname:
        client.registered = True
        log_client(client, "registered")


USER = CommandHandler("USER", 4, handle_user)
